%*define (SLC(byt))
(
 	MOV	A, %byt
	RLC	A
	MOV	%byt, A
)

       NAME    MULMOD
;-------- MUL, DIV operations follow.
        EXTRN   CODE (iADD, iSUB)
        PUBLIC  iMUL, iDIV              ; for assembler
        PUBLIC  MUL0, DIV0, ?MUL0?Byte, ?DIV0?Byte ; for PLMs
        PUBLIC  MUL1, DIV1, ?MUL1?Byte, ?DIV1?Byte
        PUBLIC  MUL2, DIV2, ?MUL2?Byte, ?DIV2?Byte
        PUBLIC  MUL3, DIV3, ?MUL3?Byte, ?DIV3?Byte

?MUL0?Byte EQU  1;Start from R1 of bank_0
?DIV0?Byte EQU  1
?MUL1?Byte EQU  9;Start from R1 of bank_1
?DIV1?Byte EQU  9
?MUL2?Byte EQU  17;Start from R1 of bank_2
?DIV2?Byte EQU  17
?MUL3?Byte EQU  25;Start from R1 of bank_3
?DIV3?Byte EQU  25

RecPtr  EQU     R1
HOp     EQU     R2
LOp     EQU     R3
W3      EQU     R4
W2      EQU     R5
W1      EQU     R6
W0      EQU     R7
Wptr    EQU     R0
ByteCounter     EQU     DPL
BitCounter      EQU     DPH
RecLowByte      EQU     B

        Math2   SEGMENT CODE;-----------------
        RSEG    Math2
LSWA:;--- Left Shift  CY <- W..W <- Math.Rec <- 0
        MOV     ByteCounter,#4
	MOV	A,RecLowByte
	MOV	Wptr, A
	CLR	CY
LSWA1:  %SLC(@Wptr)
        DEC     WPtr
        DJNZ    ByteCounter, LSWA1
	%SLC(W0)
	%SLC(W1)
	%SLC(W2)
	%SLC(W3)
	RET


MDinit:;--- Return in ACC= pointer to W3,W2,W1,W0
	MOV	A, RecPtr
	ADD	A,#3
	MOV	RecLowByte,A
	MOV	A,PSW
	ANL	A,#18H
	ORL	A,#4
        MOV     BitCounter, #32
	RET


iMUL:;---------  Accumultor = Accumultor * Operand
MUL0:
MUL1:
MUL2:
MUL3:
	LCALL	MDinit
;----- Move Math.Record to W3..W0 with Clear
	MOV	Wptr,A
	MOV	ByteCounter,#4
M0loop:	CLR	A
	XCH	A, @RecPtr
	MOV	@Wptr, A
	INC	RecPtr
	INC	Wptr
	DJNZ	ByteCounter, M0loop
	DEC	RecPtr
	DEC	RecPtr
	DEC	RecPtr
	DEC	RecPtr

Mloop:;------ Loop by each bit
	LCALL	LSWA
	JNC	OverAdd
	LCALL	iADD
OverAdd:
        DJNZ    BitCounter, MLoop
        RET



iDIV:;---- Rec = Rec/Operand, W..W=Remainder
DIV0:
DIV1:
DIV2:
DIV3:
        ;-----Clear work area
	LCALL	MDinit
	MOV	RecPtr, A; switch to W..W accumulator
	CLR	A; 	and clear it
	MOV	W0,A
	MOV	W1,A
	MOV	W2,A
	MOV	W3,A
Dloop:;-----Loop by each bit
	LCALL    LSWA
        LCALL   iSUB;---- substruct attempt
        JNC     SetLowBit
        LCALL   iADD
        LJMP    OverSetLowBit
SetLowBit:;---------------
        MOV     A,RecLowByte
        MOV     WPtr, A
        MOV     A, @WPtr
        ORL     A, #1
        MOV     @WPtr, A
OverSetLowBit:;-----------
        DJNZ    BitCounter, DLoop
	MOV	A, RecLowByte; -- retrieve RecPtr
	ADD	A, #(-3)
	MOV	RecPtr, A
        RET

        END
