        NAME    TBLMOD
;--------Linear Tabled Interpolation follows.

        PUBLIC  iTBL             ; for assembler calls
        PUBLIC  TBL0, ?TBL0?Byte ; for PLMs calls
        PUBLIC  TBL1, ?TBL1?Byte
        PUBLIC  TBL2, ?TBL2?Byte
        PUBLIC  TBL3, ?TBL3?Byte
        EXTRN   CODE (iLESS, iGREATER, iMUL, iDIV, iADD, iSUB)
	EXTRN	CODE (iClear, iINvert)

?TBL0?Byte EQU 1; uses bank 0!  Start from R1 etc.
?TBL1?Byte EQU 9; uses bank 1!  Start from R1 etc.
?TBL2?Byte EQU 17;uses bank 2!  Start from R1 etc.
?TBL3?Byte EQU 25;uses bank 3!  Start from R1 etc.

RecPtr  EQU     R1; --- Formal parameters
HTblPtr EQU     R2
LTblPtr EQU     R3
Len     EQU     R4

Index   EQU     R0; --- work reg.s
HOp     EQU     R2
LOp     EQU     R3
Positive_Slope  EQU     F0
        Math2   SEGMENT CODE
        RSEG    Math2
MoveWord:;---- Move constant at @Len+DPTR to DATA at @Index
        MOV     R7, #2
MWLoop: MOV     A, Len
        MOVC    A, @A+DPTR
        MOV     @Index, A
        INC     Index
        INC     Len
        DJNZ    R7, MWLoop
        RET

L_H_Save:;--- (Rec.LoWord - Rec.HiWord) -->Stack
        POP     ACC;--save return address
        MOV     R6, A
        POP     ACC
        MOV     R7, A
        MOV     A, RecPtr;-- at low byte of record
        ADD     A, #3
        MOV     Index, A
        INC     RecPtr
        CLR     CY
        MOV     A, @Index
        SUBB    A, @RecPtr
        PUSH    ACC
        DEC     Index
        DEC     RecPtr
        MOV     A, @Index
        SUBB    A, @RecPtr
        PUSH    ACC
        MOV     A, R7;---Return
        PUSH    ACC
        MOV     A, R6
        PUSH    ACC
        RET

iRET:;----Return after boundary check foult
	MOV	A,RecPtr
	MOV	Index,A
	MOV	A,#0
	MOV	@Index,A
	INC	Index
	MOV	@Index,A
	INC	Index
	LCALL	MoveWord
        RET


iTBL:
TBL0:
TBL1:
TBL2:
TBL3:
        MOV     A, HTblPtr;--- Prepare check boundaries
        MOV     DPH, A
        MOV     A, LTblPtr
        MOV     DPL, A
        MOV     A, RecPtr
        MOV     Index, A
        MOV     A, Len;--- Len= Len*4-2
	DEC	A
        RL      A
	RL	A
        MOV     Len, A
	MOV	B,   A

         ;---- Check right bound
        LCALL   MoveWord
        LCALL   iLess
        JC      Continue1
	LJMP	iRET; -- Exit with Y max

Continue1:;----- Check left bound
        MOV     A, RecPtr
        MOV     Index, A
        MOV     Len, #0
        LCALL   MoveWord
        LCALL   iGreater
        JC      Continue2
        LJMP	iRET;--- Exit with Y min

Continue2:;--- Search for Xi-1 < X < Xi
        MOV     A, B;-- step to left
        ADD     A, #(-4)
	MOV	Len, A
Continue3:
        MOV     A, RecPtr
        MOV     Index, A
        LCALL   MoveWord
        MOV	A, Len;-- step to left to Xi-1
        ADD     A, #(-6)
        MOV     Len, A
        LCALL   iGreater
        JNC     Continue3

        LCALL   L_H_Save;-- Calculate X - (Xi-1)

        MOV     A, RecPtr;----Calc. Xi - (Xi-1)
        ADD     A, #2
        MOV     Index, A
	MOV	A, Len
	ADD	A, #8; -- point to Xi
	MOV	Len, A
        LCALL   MoveWord
        LCALL   L_H_Save
        ;-- Now Len points to Yi
        MOV     A, RecPtr;----Calc. Yi - (Yi-1)
        ADD     A, #2
        MOV     Index, A
        LCALL   MoveWord
        MOV     A, RecPtr;
        MOV     Index, A
        MOV     A, Len
        ADD     A, #(-6)
        MOV     Len, A
        LCALL   MoveWord
        LCALL   iGreater
        MOV     Positive_slope, C
        LCALL   L_H_Save

        INC     RecPtr;--- (Yi-1) --> Stack
        MOV     A, @RecPtr
        PUSH    ACC
        DEC     RecPtr
        MOV     A, @RecPtr
        PUSH    ACC

;----  Now, in the stack there are:
; lo(X-(Xi-1)),  hi(X-(Xi-1))
; lo(Xi-(Xi-1)), hi(Xi-(Xi-1))
; lo(Yi-(Yi-1)), hi(Yi-(Yi-1))
; lo(Yi-1),      hi(Yi-1) <---SP

;Move Yi-1 to Stack at SP-7 and Move X-(Xi-1) to Math.Rec
        CLR     A
        MOV     @RecPtr, A
        INC     RecPtr
        MOV     @RecPtr, A
        INC     RecPtr
        MOV     A, SP
        ADD     A, #(-6)
        MOV     Index, A
        POP     ACC
        XCH     A, @Index
        MOV     @RecPtr, A
        INC     RecPtr
        DEC     Index
        POP     ACC
        XCH     A, @Index
        MOV     @RecPtr, A

;--------- Multiply by Yi -(Yi-1)
        MOV     A, RecPtr
        ADD     A, #(-3)
        MOV     RecPtr, A
        POP     ACC
        MOV     HOp,A
        POP     ACC
        MOV     LOp,A
        JB      Positive_Slope, Continue4
        MOV     A, LOp; sign invert
        CPL     A
        ADD     A, #1
        MOV     LOp, A
        MOV     A, HOp; sign invert
        CPL     A
        ADDC    A, #0
        MOV     HOp, A
Continue4:
        LCALL   iMUL

;--------- Divide by Xi -(Xi-1)
        POP     ACC
        MOV     HOp,A
        POP     ACC
        MOV     LOp,A
        LCALL   iDIV

;--------- Add Yi-1
        POP     ACC
        MOV     HOp,A
        POP     ACC
        MOV     LOp,A
        JNB     Positive_Slope, Continue5
        LCALL   iADD
        RET

Continue5:
        LCALL   iSUB
        LCALL   iINVERT
        RET

        END
